#include "compresser_bitmap.h"
#include "bmp_headers.h"
#include "rgb_value.h"
#include "compresser_rle.h"
#include "minuter.h"
#include <fstream>
#include <chrono>
#include <iostream>
#include <string>
#include <vector>
using namespace std;
using namespace std::chrono;

void compresser_bitmap_rle(const string &nom) {
   ifstream ifs{ nom, ios::binary };
   if (bitmap bmp; ifs && ifs >> bmp) {
      vector<rgb_value> vrgb;
      {
         auto ecoule = tester([&]() {
            vrgb = to_rgb_values(bmp.raw_data);
            return 0;
         });
         cout << "Raw --> RGB, une image a la fois, " << bmp.raw_data.size() << " bytes" << endl;
      }
      vector<uint32_t> v_rle;
      auto ecoule = tester([&]() {
         v_rle = compresser_rle<uint32_t>(vrgb);
         return 0;
      });
      cout << "Compression RLE, une image, " << bmp.raw_data.size() << " bytes" << endl;
#ifdef _DEBUG
      auto nbytes = v_rle.size() * sizeof(uint32_t);
      cout << "Aprs compression RLE: " << nbytes << " bytes" << endl;
#endif
   }
#ifdef _DEBUG
   else
      cerr << "Erreur de lecture, fichier " << nom << endl;
#endif
}
