#ifndef MINUTER_H
#define MINUTER_H

#include <chrono>
#include <utility>

template <class F, class ... Args>
   auto tester(F f, Args && ... args) {
      using namespace std::chrono;
      auto pre = high_resolution_clock::now();
      auto res = f(std::forward<Args>(args)...);
      auto post = high_resolution_clock::now();
      return make_pair(res, post - pre);
   }

#endif
